import java.lang.*;
import java.util.Vector;

class FinalHorse {
// boardDimensions
public static int dimx=0, dimy=0, dimz=0, numlength=1;

// set board Dimensions
	public static void setDim(int x, int y, int z) throws Exception {
		if(x < 5 || y < 5 || z < 5) throw new Exception("Invalid Dimension, Must be 5 or higher");
		FinalHorse.dimx = x;
		FinalHorse.dimy = y;
		FinalHorse.dimz = z;
		
		// Define numberlength for boardprinting
		double temp = x*y*z;
		FinalHorse.numlength = 1;
		while(temp >= 10){
			temp /= 10.0;
			FinalHorse.numlength++;
		}
	}

// findpath from beginpoint given #precalculated of heuristicaly determined beginpoints
	public static Vector findpath(HorsePoint beginpoint, int precalculated, boolean printboard) {
		
		// Init TimeTesting variable's
		long precalc,postcalc,predf,postdf,dfdif,nodes=0;
	
		// Start Timer
		precalc = System.currentTimeMillis();
		
		// Init paths
		Vector beginpath = HorsePoint.GiveFirstXPoints(beginpoint,precalculated);
		postcalc = System.currentTimeMillis();	// End Timer
		Vector path = new Vector();
		path = (Vector) beginpath.clone();
		
		// Message
		System.out.println("Chessfield is "+dimx+"x"+dimy+"x"+dimz+" containing "+dimx*dimy*dimz+" fields");
		System.out.println("Using "+precalculated+" heuristicaly determined beginpoints");
		
		// Start 2nd Timer
		predf = System.currentTimeMillis();
		
		while(path.size() != dimx*dimy*dimz) {
		nodes++;
		HorsePoint currentpoint = (HorsePoint) path.lastElement();
		HorsePoint nextpoint = currentpoint.NextPoint();
		
		if(nextpoint.InBoard() && nextpoint.notIn(path) && currentpoint.conf < 25) path.add(nextpoint); // legal move\
		else { 
			path.removeElementAt(path.size() -1); 
			if(currentpoint.conf != 24) path.add(new HorsePoint(currentpoint.x, currentpoint.y, currentpoint.z, currentpoint.conf + 1));
			if(currentpoint.conf == 24) {
				while(currentpoint.conf == 24) {
				currentpoint = (HorsePoint) path.lastElement();
				path.removeElementAt(path.size() - 1);
				}
				path.add(new HorsePoint(currentpoint.x, currentpoint.y, currentpoint.z, currentpoint.conf+1));
			}
		}
		}
		// End 2nd Timer
		postdf = System.currentTimeMillis();
		dfdif = postdf - predf;
		
		// Messages
		if(printboard) {
			System.out.println("");
			FinalHorse.printboard(path);
		//System.out.println(path);
			System.out.println("");
		}
		System.out.println("The Heuristic Calculations Took: "+ ((postcalc - precalc) / 1000.0) + " sec");
		System.out.println("The DepthFirst Search Took: "+ ((dfdif / 1000.0) < 60 ? ((dfdif / 1000.0)+" sec") : ((int) Math.floor((dfdif / 60000.0))+" min, "+ ((dfdif - Math.floor((dfdif / 60000.0))*60000) / 1000.0) + " sec" )));
		System.out.println("The DepthFirst Search Checked "+nodes+" Nodes.");
		
		// return the found path
		return (Vector) path.clone();
	}
	
	static void printboard(Vector p) {
		// initialize board
		int board[][][] = new int[dimx][dimy][dimz];
		
		// add points
		for(int i =0; i < p.size(); i++){
			HorsePoint at = (HorsePoint) p.elementAt(i);
			board[at.x][at.y][at.z] = i+1;
		}
		
		//print the board
		for(int z=0; z < dimz; z++) {
		System.out.println("Layer "+z);
		for(int y =0; y < dimy; y++) {
			for(int i =0; i < dimx*FinalHorse.numlength+(dimx+1); i++) {
				System.out.print("+");
			}
			System.out.println("");
			for(int j =0; j < dimx*2+1; j++) {
				if(j % 2 == 0) System.out.print("+");
				if(j % 2 == 1) System.out.print(formatnum(board[(j-1)/2][dimy-y-1][z]));
			}
			System.out.println("");
		}
		for(int i =0; i < dimx*FinalHorse.numlength+(dimx+1); i++) {
				System.out.print("+");
		}
		System.out.println("");
		}
	}
	
	// Format the numbers to desired length
	private static String formatnum(int n) {
		String temp = ""+n;
		while(temp.length() < FinalHorse.numlength)
			temp = "0"+temp;
		return temp;
	}
}