import java.lang.*;
import java.util.Vector;

class HorsePoint {
// Class variable's
public int x,y,z,conf;

// Constructor
	HorsePoint(int x,int y,int z, int conf) {
	this.x = x;
	this.y = y;
	this.z = z;
	this.conf = conf;
	}

// Calculate a next point, given an origin point and a desidered direction (the conf variable)
	public HorsePoint NextPoint() {
	int newx = 0, newy = 0, newz=0;
	switch(conf) {
	case 1: newx = this.x - 2; newy = this.y + 1; newz = this.z; break;
	case 2: newx = this.x - 2; newy = this.y - 1; newz = this.z; break;
	case 3: newx = this.x - 1; newy = this.y - 2; newz = this.z; break;
	case 4: newx = this.x + 1; newy = this.y - 2; newz = this.z; break;
	case 5: newx = this.x + 2; newy = this.y - 1; newz = this.z; break;
	case 6: newx = this.x + 2; newy = this.y + 1; newz = this.z; break;
	case 7: newx = this.x + 1; newy = this.y + 2; newz = this.z; break;
	case 8: newx = this.x - 1; newy = this.y + 2; newz = this.z; break;
	
	case 9: newx = this.x; newy = this.y - 2; newz = this.z +1; break;
	case 10: newx = this.x; newy = this.y - 2; newz = this.z -1; break;
	case 11: newx = this.x; newy = this.y - 1; newz = this.z -2; break;
	case 12: newx = this.x; newy = this.y + 1; newz = this.z -2; break;
	case 13: newx = this.x; newy = this.y + 2; newz = this.z -1; break;
	case 14: newx = this.x; newy = this.y + 2; newz = this.z +1; break;
	case 15: newx = this.x; newy = this.y + 1; newz = this.z +2; break;
	case 16: newx = this.x; newy = this.y - 1; newz = this.z +2; break;
	
	case 17: newx = this.x - 2; newy = this.y; newz = this.z+1; break;
	case 18: newx = this.x - 2; newy = this.y; newz = this.z-1; break;
	case 19: newx = this.x - 1; newy = this.y; newz = this.z-2; break;
	case 20: newx = this.x + 1; newy = this.y; newz = this.z-2; break;
	case 21: newx = this.x + 2; newy = this.y; newz = this.z-1; break;
	case 22: newx = this.x + 2; newy = this.y; newz = this.z+1; break;
	case 23: newx = this.x + 1; newy = this.y; newz = this.z+2; break;
	case 24: newx = this.x - 1; newy = this.y; newz = this.z+2; break;
	default: break;
	}
	return new HorsePoint(newx, newy, newz,  1);
	}

// Checks if a certain location isn't already in the path vector
	public boolean notIn(Vector p) {
	for(int i = 0; i < p.size(); i++) {
	HorsePoint check = (HorsePoint) p.elementAt(i);
	if(check.x == this.x && check.y == this.y && check.z == this.z) return false;
	}
	return true;
	}

// Checks if the location is within the board
	public boolean InBoard() {
	return (this.x > -1 && this.x < FinalHorse.dimx && this.y > -1 && this.y < FinalHorse.dimy && this.z > -1 && this.z < FinalHorse.dimz);
	}

// Convert the coordinates to a String
	public String toString() {
	return ""+this.x+";"+this.y+";"+this.z;
	}

// Calculates the number of the locations that can be jumped to from the origin point	
	private int ReachableNumber(Vector P) {
		int Reachable = 0;
		HorsePoint check = new HorsePoint(this.x, this.y, this.z, 1);
		HorsePoint[] points = new HorsePoint[24];
		
		for(int i = 1; i < points.length+1; i++) {
		check.conf = i;
		points[i-1] = check.NextPoint();
		}
		
		for(int i = 1; i < points.length+1; i++) {
		if(points[i-1].InBoard() && points[i-1].notIn(P)) Reachable++;
		}
		
		return Reachable;
	}

// Heuristicaly determines the next point from an origin point
// The heuristic takes the point with the lowest ReachableNumber value
	public HorsePoint HeuristicNextPoint(Vector P) {
		HorsePoint check = new HorsePoint(this.x, this.y, this.z, 1);
		HorsePoint[] points = new HorsePoint[24];
		
		for(int i = 1; i < points.length+1; i++) {
		check.conf = i;
		points[i-1] = check.NextPoint();
		}
		
		int index = 0;
		int smallest = 999;
		
		for(int i = 0; i < points.length; i++) {
			if(points[i].ReachableNumber(P) < smallest && points[i].InBoard() && points[i].notIn(P)) { index = i; smallest = points[i].ReachableNumber(P); }
		}
		
		return points[index];
	}
	
// Static function returns a heuristicaly determined beginpath of length HowMany
	public static Vector GiveFirstXPoints(HorsePoint begin, int HowMany) {
	Vector heurpath = new Vector();
	heurpath.add(begin);
	for(int i=0; i < HowMany -1; i++) {
		HorsePoint last = (HorsePoint) heurpath.lastElement();
		HorsePoint newpoint = last.HeuristicNextPoint(heurpath);
		heurpath.add(newpoint);
	}
	
	return (Vector) heurpath.clone();
	}
}