import java.io.*;
import java.lang.*;
import java.util.Vector;
import java.awt.*;
import javax.swing.*;

public class PP {
  private static double MOVE_HEIGHT_HIGH=30;
  private static double MOVE_HEIGHT_LOW=10;
  private static double HORSE_HEIGHT=58;
  private static double SAFE_HEIGHT=200;
  private static double LOW_HEIGHT=40;
  private static double OPEN_GRIP=30;
  private static double CLOSED_GRIP=0;

  public static void main(String[] args){
    Vector p = new Vector();
    String computerFrom, computerTo;
    ChessBoard b = new ChessBoard();

    /* Read the board state*/
    b.read();

   
    	try{
	knightstour(b, p);
	}
	catch(IOException e) {
	System.out.println(e);
	System.exit(0);
	}
    /* after done write the gripper positions */
    GripperPosition.write(p);
    IK.main(new String[1]);
  }

  
  private static void knightstour(ChessBoard b, Vector p) throws IOException {
  	System.out.println("***** In Knightstour");

	BufferedReader stdin = 
			new BufferedReader( new InputStreamReader( System.in ) );
			
		// Ask user for input
		System.out.println("Which starting position do you want the knight to have?");
		System.out.println("X-location: (0-7)");
		String xloc = stdin.readLine();
		System.out.println("Y-location: (0-7)");
		String yloc = stdin.readLine();
		
		// Set given Dimensions
		try {
		FinalHorse.setDim(8,8);
		}
		catch(Exception e) {
			System.out.println(e);
			System.exit(0);
		}
		
		// Ask user for input
		System.out.println("");
		System.out.println("How many of the "+ FinalHorse.dimx*FinalHorse.dimy+" locations do you want to be heuristically determined?");
		String precalc = stdin.readLine();
		Vector path = FinalHorse.findpath(new HorsePoint(Integer.parseInt(xloc),Integer.parseInt(yloc),1), Integer.parseInt(precalc), true);

		
		int[][] board = new int[8][8];
		
		JFrame kframe = new JFrame("Knights Tour Search");
		Container pane = kframe.getContentPane();
		
		DrawingCanvas kcanvas = new DrawingCanvas(board, 40);
		pane.add(kcanvas);
		kframe.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		kframe.pack();
		kframe.show();
		kframe.toFront();
		
		animate(path,600,kcanvas);
		

		 	// Calculate half pieceheight
			double half_pieceheight = HORSE_HEIGHT/2;
			
			double angle = -90;
			
			// Move to origin point and grip the chess piece
			HorsePoint FP = (HorsePoint) path.firstElement();
			Point FPC = b.toCartesian(FP.y,FP.x);
			Point FPC1 = new Point(FPC.x, FPC.y, FPC.z + SAFE_HEIGHT);
			Point FPC2 = new Point(FPC.x, FPC.y, FPC.z + LOW_HEIGHT);
			Point FPC3 = new Point(FPC.x, FPC.y, FPC.z + half_pieceheight);
			
			p.add(new GripperPosition(FPC1, angle, OPEN_GRIP));
			p.add(new GripperPosition(FPC2, angle, OPEN_GRIP));
			p.add(new GripperPosition(FPC3, angle, OPEN_GRIP));
			p.add(new GripperPosition(FPC3, angle, CLOSED_GRIP));
			
			// move over planned lowpath positions, coordinates are transformed to cartesian coordinates
			for(int i = 1; i < path.size(); i++) {	
				HorsePoint TPO = (HorsePoint) path.elementAt(i-1);	
				HorsePoint TPN = (HorsePoint) path.elementAt(i);
				Point TPtussen, TPeind;
				if(TPN.y - TPO.y == 2) {
				TPtussen = b.toCartesian(TPO.y+1,TPO.x);
				TPeind = b.toCartesian(TPN.y,TPN.x);
				}
				else if(TPN.y - TPO.y == -2) {
				TPtussen = b.toCartesian(TPO.y-1,TPO.x);
				TPeind = b.toCartesian(TPN.y,TPN.x);
				}
				else if(TPN.x - TPO.x == 2) {
				TPtussen = b.toCartesian(TPO.y,TPO.x+1);
				TPeind = b.toCartesian(TPN.y,TPN.x);
				}
				else{
				TPtussen = b.toCartesian(TPO.y,TPO.x-1);
				TPeind = b.toCartesian(TPN.y,TPN.x);
				}
				Point RPtussen = new Point(TPtussen.x, TPtussen.y, TPtussen.z + MOVE_HEIGHT_HIGH + half_pieceheight);
				Point RPeind = new Point(TPeind.x, TPeind.y, TPeind.z + MOVE_HEIGHT_LOW + half_pieceheight);
				p.add(new GripperPosition(RPtussen, angle, CLOSED_GRIP));
				p.add(new GripperPosition(RPeind, angle, CLOSED_GRIP));
			}
			
			// Drop the piece at the destination point and move back to safe height again
			HorsePoint LP = (HorsePoint) path.lastElement();
			Point LPC = b.toCartesian(LP.y,LP.x);
			Point LPC1 = new Point(LPC.x, LPC.y, LPC.z + half_pieceheight);
			Point LPC2 = new Point(LPC.x, LPC.y, LPC.z + LOW_HEIGHT);
			Point LPC3 = new Point(LPC.x, LPC.y, LPC.z + SAFE_HEIGHT);
			
			p.add(new GripperPosition(LPC1, angle, CLOSED_GRIP));
			p.add(new GripperPosition(LPC1, angle, OPEN_GRIP));
			p.add(new GripperPosition(LPC2, angle, OPEN_GRIP));
			p.add(new GripperPosition(LPC3, angle, OPEN_GRIP));
			

  	}

		//call gui
		private static void animate(Vector g,int pause, DrawingCanvas screen) {
		for(int i=0; i < g.size(); i++) {
		HorsePoint p = (HorsePoint) g.elementAt(i);
		screen.setCell(p.x, p.y,i+1);
		screen.repaint();
		try{
		Thread.sleep(pause);
		}
		catch(InterruptedException e){
		System.out.println("Sleep Interrupted");
		}
		}
		}
  }


